/***************************************************************** 
  bip2biln 

	convert double BIP to BIL

  bil2bipn
	convert double BIL to BIP

	data: double data
	nrow: number of row
	ncol: number of column
	nband: number of band
	nbyte: number of byte
		  	
by Dr. Hoonyol Lee 
Dept. of Geophysics
Kangwon National Univeristy
29 June 2004
12 August 2006: bip2bil, bil2bip
*****************************************************************/ 
/*#include "ma.c" */

void bip2biln(data, nrow, ncol, nband) 
double *data;
int nrow, ncol, nband;
{
	int i, j, k, ix;
	double *tmp;
	
	tmp=dvector(ncol*nband);
	
	for(i=0; i<nrow; i++)
	{
		ix=i*ncol*nband;
		for(j=0; j<ncol; j++)
		{
			for(k=0; k<nband; k++)
				tmp[j+k*ncol]=data[ix+j*nband+k];
		}

		for(j=0; j<ncol*nband; j++) data[ix+j]=tmp[j];
	}

	free(tmp);
}

void bil2bipn(data, nrow, ncol, nband) 
double *data;
int nrow, ncol, nband;
{
	int i, j, k, ix;
	double *tmp;
	
	tmp=dvector(ncol*nband);
	
	for(i=0; i<nrow; i++)
	{
		ix=i*ncol*nband;
		for(j=0; j<ncol; j++)
		{
			for(k=0; k<nband; k++)
				tmp[j*nband+k]=data[ix+j+k*ncol];
		}

		for(j=0; j<ncol*nband; j++) data[ix+j]=tmp[j];
	}

	free(tmp);
}
