/****************************************
	cshift.c

       : cyclic shift of complex double data in BIP
       : only shift by half of nrow and ncol

24 July 2006
by Hoonyol Lee
***************************************/

void cshift_x(double *data, int nrow, int ncol)
{
	int i, j, ix;
	double tmp1, tmp2;

	for(i=0; i<nrow; i++)
	{
		ix=i*ncol*2;
		for(j=0; j<ncol/2; j++)
		{
			tmp1=data[ix+j*2];
			tmp2=data[ix+j*2+1];
			data[ix+j*2]=data[ix+j*2+ncol];
			data[ix+j*2+1]=data[ix+j*2+ncol+1];
			data[ix+j*2+ncol]=tmp1;
			data[ix+j*2+ncol+1]=tmp2;
		}
	}

}

void cshift_y(double *data, int nrow, int ncol)
{
	int i, j, jx;
	double tmp1, tmp2;

	for(i=0; i<ncol; i++)
	{
		for(j=0; j<nrow/2; j++)
		{
			jx=j*ncol*2;
			tmp1=data[jx+i*2];
			tmp2=data[jx+i*2+1];
			data[jx+i*2]=data[jx+nrow*ncol+i*2];
			data[jx+i*2+1]=data[jx+nrow*ncol+i*2+1];
			data[jx+nrow*ncol+i*2]=tmp1;
			data[jx+nrow*ncol+i*2+1]=tmp2;
		}
	}
}

void cshift2d(double *data, int nrow, int ncol)
{
	cshift_x(data, nrow, ncol);
	cshift_y(data, nrow, ncol);
}

